%Script Function
%EECS 351 Project - Christopher Shih===========================
clear;clc;close all; 

%PAUSE CONTROL FOR EACH GRAPH 
pause_control = 1; 
%=====================File Load===========================
%{
Files were taken from the MIT Normal Sinus Data base from physiotools. 
%}

load 16272m.mat   %Load Signal 

ECG = val;         

N = length(ECG); %CWT resolution
Fs = 128;         
M = 10000;       %FT resolution

t = linspace(0,10,N); 
w = linspace(0, Fs, M); 

%===================Preprocessing=============================

%detrending
ECG_pre = detrend(ECG);

% LPF
if 0 % LPF
figure(); plot(ECG_pre);hold on;  
ECG_pre = lowpassfilter(ECG_pre); 
plot(ECG_pre,'r');
end

%mode shifting
ECG_pre = ECG_pre - mode(ECG); 
 
if 1 %plot processing
   figure(1); plot(t,ECG ,'r'); grid on;hold on; 
   plot(t,ECG_pre, 'b'); grid on;
   legend('Pre', 'Post');xlabel('time');ylabel('mV');title('Pre vs Post processed signal comparison'); 
end

    if pause_control
        pause;
    end

if 1 %preprocessing control
    ECG = ECG_pre;
end
%==============Wavlet analysis - finding BPM=========================
%               coif2 wavelet : Scale- 70-80
scale = 250; 
figure(2); 
ECG_cwt_coe = cwt(ECG, 1:scale, 'coif2','plot');   

    if pause_control
        pause;
    end
    
ECG_cwt = mean(ECG_cwt_coe(70:80,:));
ECG_cwt_fft_M = abs(fft(ECG_cwt,M)); 

[Y,X] =  max (ECG_cwt_fft_M);  %find max

figure(3); subplot(211), plot(t, ECG_cwt);title('ECG CWT coif2 70-80 scale average');
            xlabel('time');ylabel('mV'); %PLOT
        subplot(212), plot(w, ECG_cwt_fft_M); title('ECG CWT coif2 fft');%PLOT
            xlabel('Hz');ylabel('Coe'); 
BPM_art = 1/(2*pi) * X/(M/2)*pi * Fs;    %Angular -> Real frequency conversion
disp('BPM calculation')
disp(BPM_art*60); 

    if pause_control
        pause;
    end
%=========================================================================
%====================Wavlet analysis - Removing the QRS complex===========
figure(4) 
ECG_cwt_coe_QRS = cwt(ECG, 1:30, 'coif2','plot');
    if pause_control
        pause;
    end
    %!!!!!!!!!!!!!!!!!!!!CHANGE QRS SCALE HERE!!!!!!!!!!!!!!!!!!!!!
ECG_cwt_QRS = mean(ECG_cwt_coe(8:16,:));
        figure(5); subplot(312), plot(ECG_cwt_QRS); title('ECG CWT coif2');%PLOT
                         xlabel('time');ylabel('mV');
                         
                         %%  SEE COIFLET ALGORITHM FOR EXPLANATION
%Summary: 
%{
1. Find relative max
2. Select for relative maximums > 0.5 absolute max
3. Find two closest neighboring zeros
4. Coiflet domain between zeros == QRS domain in time domain
%}
[pks,locs] = findpeaks(ECG_cwt_QRS);
abs_max = max(pks);
%find max
for i = 1: length(locs)
    if pks(i) < abs_max/2
        pks(i) = 0; locs(i) = 0;
    end
end

locs_new = 1; 
m = 1; 
for i = 1: length(locs)
    if locs(i) ~= 0; 
        locs_new(m) = locs(i); 
        m = m + 1; 
    end
end
locs = locs_new; 
subplot(311), plot(ECG);   title('ECG signal'); xlabel('t'); ylabel('mV'); %PLOT


zero_threshold = 15;
zeros = abs(ECG_cwt_QRS) < zero_threshold;

QRS_only = 1; 
QRS_CWT_ONLY = 1; 
hold_1 = 1;
intervals = 1;
before_peak = 1; 
g = 1;
n = 1; 
for i = 1:N
    if before_peak
        if zeros(i) == 1
            hold_1 = i; 
        end
        
        if i == locs(n)
            intervals(g) = hold_1;
            g = g + 1;
                if n ~= length(locs)
                    n = n + 1;
                end
            before_peak = 0; 
        end
    end
    
    if ~before_peak 
        if zeros(i) == 1
            intervals(g) = i;
            g = g + 1; 
            before_peak = 1; 
        end
    end
end

n = 1;
zero_state = 0; 
ECG_minus_QRS = ECG; 
for i = 1:N
    
    %ECG_minus_QRS(i) = ECG(i); 
     
    if i == intervals(n) && ~zero_state
              QRS_only(i) =ECG(i); 
                QRS_CWT_ONLY(i) = ECG_cwt_QRS(i);
                
        ECG_minus_QRS(i) = 0;
        zero_state = 1; 
        
            if n ~= length(intervals); 
                 n = n + 1 ; 
            end
    end
    
    if zero_state
        ECG_minus_QRS(i) = 0;
        QRS_only(i) =ECG(i);    
        QRS_CWT_ONLY(i) = ECG_cwt_QRS(i);
                
            if i == intervals(n)
                ECG_minus_QRS(i) = 0;
                zero_state = 0;
                if n ~= length(intervals); 
                     n = n + 1 ; 
                end
            end
    end
end
%%


subplot(313), plot(t,ECG_minus_QRS); title('ECG minus QRS'); xlabel('t'); ylabel('mV'); %PLOT
save('minusQRS','ECG_minus_QRS');

    if pause_control
        pause;
    end
    
figure(6);
subplot(212);plot(t,ECG,'r');hold on; plot(t,ECG_minus_QRS);    legend('Original', 'QRS removal');title('ECG minus QRS'); xlabel('t'); ylabel('mV'); %PLOT
subplot(211), plot(t,ECG_cwt_QRS,'g'); title('ECG CWT coif2'); xlabel('t'); ylabel('Coe'); %PLOT

    if pause_control
        pause;
    end
    
%figure(7); plot(QRS_only); title('QRS only'); xlabel('t'); ylabel('mV'); 

parsevals_cwt = (QRS_CWT_ONLY).^2;
parsevals_time = (QRS_only).^2;

cwt_power = trapz(parsevals_cwt)
time_power = trapz(parsevals_time) 

    if pause_control
        pause;
    end

%%========= COMPARING ARTIFICAL SIGNAL TO REAL SIGNAL=======================
%========= COMPARING ARTIFICAL SIGNAL TO REAL SIGNAL=======================
%========= COMPARING ARTIFICAL SIGNAL TO REAL SIGNAL=======================
%========= COMPARING ARTIFICAL SIGNAL TO REAL SIGNAL=======================

BPM = BPM_art * 60; 
[t_art ECG_art N duration] = create_ECG(0.25, 0.2, 1.6, 0.40, 0.3,...
    0.16, 0.3, 0.1, 0.11, 0.09, BPM);

ECG = [ECG_art ECG_art ECG_art ECG_art ECG_art ECG_art];

N = N * 6; 
t = linspace( 0, 6 * duration, N) ; 

figure(11) 
ECG_cwt_coe_QRS = cwt(ECG, 5:500, 'coif2','plot');
    if pause_control
        pause;
    end
    
    %!!!!!!!!!!!!!!!!!!!!CHANGE QRS SCALE HERE!!!!!!!!!!!!!!!!!!!!!  
ECG_cwt_coe = cwt(ECG, 1:512, 'coif2');   

ECG_cwt_QRS = mean(ECG_cwt_coe(2*6:16*6,:));
        figure(12); subplot(312), plot(ECG_cwt_QRS); title('ECG CWT coif2');%PLOT
                         xlabel('time');ylabel('mV');
                         
                         %%  SEE COIFLET ALGORITHM FOR EXPLANATION
%Summary: 
%{
1. Find relative max
2. Select for relative maximums > 0.5 absolute max
3. Find two closest neighboring zeros
4. Coiflet domain between zeros == QRS domain in time domain
%}
[pks,locs] = findpeaks(ECG_cwt_QRS);
abs_max = max(pks);
%find max
for i = 1: length(locs)
    if pks(i) < abs_max/2
        pks(i) = 0; locs(i) = 0;
    end
end

locs_new = 1; 
m = 1; 
for i = 1: length(locs)
    if locs(i) ~= 0; 
        locs_new(m) = locs(i); 
        m = m + 1; 
    end
end
locs = locs_new; 
subplot(311), plot(ECG);   title('ECG signal'); xlabel('t'); ylabel('mV'); %PLOT


zero_threshold = 0.01;
zeros = abs(ECG_cwt_QRS) < zero_threshold;

QRS_only = 1; 
QRS_CWT_ONLY = 1; 
hold_1 = 1;
intervals = 1;
before_peak = 1; 
g = 1;
n = 1; 
for i = 1:N
    if before_peak
        if zeros(i) == 1
            hold_1 = i; 
        end
        
        if i == locs(n)
            intervals(g) = hold_1;
            g = g + 1;
                if n ~= length(locs)
                    n = n + 1;
                end
            before_peak = 0; 
        end
    end
    
    if ~before_peak 
        if zeros(i) == 1
            intervals(g) = i;
            g = g + 1; 
            before_peak = 1; 
        end
    end
end

n = 1;
zero_state = 0; 
ECG_minus_QRS = ECG; 
for i = 1:N
    
    %ECG_minus_QRS(i) = ECG(i); 
     
    if i == intervals(n) && ~zero_state
              QRS_only(i) =ECG(i); 
                QRS_CWT_ONLY(i) = ECG_cwt_QRS(i);
                
        ECG_minus_QRS(i) = 0;
        zero_state = 1; 
        
            if n ~= length(intervals); 
                 n = n + 1 ; 
            end
    end
    
    if zero_state
        ECG_minus_QRS(i) = 0;
        QRS_only(i) =ECG(i);    
        QRS_CWT_ONLY(i) = ECG_cwt_QRS(i);
                
            if i == intervals(n)
                ECG_minus_QRS(i) = 0;
                zero_state = 0;
                if n ~= length(intervals); 
                     n = n + 1 ; 
                end
            end
    end
end
%%


subplot(313), plot(t,ECG_minus_QRS); title('ECG minus QRS'); xlabel('t'); ylabel('mV'); %PLOT
save('minusQRS','ECG_minus_QRS');

    if pause_control
        pause;
    end
    
figure(13);
subplot(212);plot(t,ECG,'r');hold on; plot(t,ECG_minus_QRS);    legend('Original', 'QRS removal');title('ECG minus QRS'); xlabel('t'); ylabel('mV'); %PLOT
subplot(211), plot(t,ECG_cwt_QRS,'g'); title('ECG CWT coif2'); xlabel('t'); ylabel('Coe'); %PLOT

    if pause_control
        pause;
    end
    
    
%figure(7); plot(QRS_only); title('QRS only'); xlabel('t'); ylabel('mV'); 

parsevals_cwt = (QRS_CWT_ONLY).^2;
parsevals_time = (QRS_only).^2;

cwt_power_art = trapz(parsevals_cwt)/6
time_power_art = trapz(parsevals_time) 

    if pause_control
        pause;
    end
