clear all; close all; clc;
%Pre-processing and loading of EKG signal
%Christian Paritt

EKG = importdata('16272m.mat');
EKG_D = detrend(EKG); 
N = length(EKG_D); 
t = 10; 
Fs = N/t;
Fmax = Fs/2;
%BPM code
figure();
EKG_DB6 = cwt(EKG_D,2:.2:164,'db6','plot');
M_EKG_DB6 = mean(EKG_DB6);
D_M_EKG_DB6 = detrend(M_EKG_DB6);
FFT_D_M_EKG_DB6 = fft(D_M_EKG_DB6,10000);
Mag_FFT_D_M_EKG_DB6 = abs(FFT_D_M_EKG_DB6);
figure();
plot(Mag_FFT_D_M_EKG_DB6);
[Peak,n0] = max(Mag_FFT_D_M_EKG_DB6(:,1:640));
f0 = Fmax*(2*n0)/10000;
BPM_DB = f0*60;
display (BPM_DB);

%QRS removal code using team devoleped algorithm
figure();
EKG_DB4 = cwt(EKG_D,2:.002:10,'db4','plot');
M_EKG_DB4 = mean(EKG_DB4);
D_M_EKG_DB4 = M_EKG_DB4;
figure();
plot(D_M_EKG_DB4);

EKG_cwt_QRS = D_M_EKG_DB4;
        figure(); subplot(311), plot(EKG_cwt_QRS); title('EKG CWT DB4');%PLOT
[pks,locs] = findpeaks(EKG_cwt_QRS);
abs_max = max(pks);
%find max
for i = 1: length(locs)
    if pks(i) < abs_max/2
        pks(i) = 0; locs(i) = 0;
    end
end

locs_new = 1; 
m = 1; 
for i = 1: length(locs)
    if locs(i) ~= 0; 
        locs_new(m) = locs(i); 
        m = m + 1; 
    end
end
locs = locs_new; 
subplot(312), plot(EKG_D);   title('EKG signal');%PLOT

zero_threshold = 15;
zeros = abs(EKG_cwt_QRS) < zero_threshold;

hold = 1;
intervals = 1;
before_peak = 1; 
g = 1;
n = 1; 
for i = 1:N
    if before_peak
        if zeros(i) == 1
            hold = i; 
        end
        
        if i == locs(n)
            intervals(g) = hold;
            g = g + 1;
                if n ~= length(locs)
                    n = n + 1;
                end
            before_peak = 0; 
        end
    end
    
    if ~before_peak 
        if zeros(i) == 1
            intervals(g) = i;
            g = g + 1; 
            before_peak = 1; 
        end
    end
end

n = 1;
zero_state = 0; 
EKG_minus_QRS = EKG_D; 
for i = 1:N
    
    %ECG_minus_QRS(i) = ECG(i); 
    
    if i == intervals(n) && ~zero_state
        EKG_minus_QRS(i) = 0;
        zero_state = 1; 
            if n ~= length(intervals); 
                 n = n + 1 ; 
            end
    end
    
    if zero_state
        EKG_minus_QRS(i) = 0;
            if i == intervals(n)
                EKG_minus_QRS(i) = 0;
                zero_state = 0;
                if n ~= length(intervals); 
                     n = n + 1 ; 
                end
            end
    end
end

subplot(313), plot(EKG_minus_QRS);     title('EKG minus QRS');%PLOT

