%EECS 351 Project - Christopher Shih=====================
clear;clc;
ECG = physio_10s('105.dat')./1000;
Fs = 360;

ECG_raw = ECG;
ECG_shift = ECG - mean(ECG); 
tn = linspace(0,10, 3600); 
w = linspace(0,2.*pi, 3600); 
Hz_360 = linspace(-Fs/2,Fs/2, 3600);    

M = length(ECG); 

ECG_fft = fft(ECG); 
ECG_fft(1,1) = 0; 

%detrending===================================================
ECG_detrend= detrend(ECG_raw);

if 0 %plot detrend
    plot(ECG_raw ,'r');
    plot(ECG_detrend, 'b');
    grid on;
end

%===============================================================
%Create Filter
N = 7;
Fp = 15;
Ap = 1;

h  = fdesign.lowpass('N,Fp,Ap', N, Fp, Ap, Fs);
d = design(h, 'cheby1');

ECG_cheby = filter(d,ECG_detrend);

%finding BPM
ECG_cheby_fft= fft(ECG_cheby); 

figure()
subplot(4,1,1), plot(tn,ECG); title('ECG raw'); 
subplot(4,1,2), plot(Hz_360,abs(ECG_fft)); title('ECG raw fft'); 
subplot(4,1,3), plot(tn,ECG_cheby); title('ECG cheby filter'); 
subplot(4,1,4), plot(Hz_360,abs(ECG_cheby_fft)); title('ECG cheby filter fft)'); 


%BPM wavlet calculation
[BPM ECG_cheby_wavlet] = BPM_Time(ECG_cheby, Fs, 10); 
ECG_cheby_wavlet_fft = fft(ECG_cheby_wavlet);

figure()
subplot(3,1,1), plot(tn,ECG_cheby) ; title('ECG cheby'); 
subplot(3,1,2), plot(tn,ECG_cheby_wavlet) ; title('ECG cheby wavlet'); 
subplot(3,1,3), plot(Hz_360,abs(ECG_cheby_wavlet_fft));title('ECG cheby wavlet fft');

[Y X] = max (abs(ECG_cheby_wavlet_fft)); 
BPM_ECG_wavlet_fft = (X/(3600/2))*180  .*60  

%Creation and comparison to normal 
[t_art ECG_art N duration] = create_ECG(0.25, 0.2, 1.6, 0.40, 0.3,...
    0.16, 0.3, 0.1, 0.11, 0.09, 90);


[BPM_art ECG_art_wavlet] = BPM_Time(ECG_cheby,N, duration); 
ECG_art_wavlet_fft = fft(ECG_art_wavlet);

figure()
subplot(3,1,1), plot(t_art,ECG_art) ; title('ECG art'); 
subplot(3,1,2), plot(ECG_art_wavlet); title('ECG art wavlet');
subplot(3,1,3), plot(abs(ECG_art_wavlet_fft)); title('ECG art wavlet fft');

[Y X] = max (abs(ECG_art_wavlet_fft)); 
BPM_art = (X/(3600/2))*180  .*60  




%{
N = 100;
greater_than_N = DFT_P_105 > N; 
DFT_P_105 = DFT_P_105 .* ~greater_than_N;


figure()
subplot(3,1,1), plot(abs(DFT_ECG))
subplot(3,1,2), plot(ECG_cheby)
subplot(3,1,3), plot(ECG)

F_DFT_P_105 = ifft(DFT_ECG); 



figure;
plot(tn, ECG_shift, 'b',tn, ECG_cheby,'r');
grid on;
legend({'Original Signal','Filtered Signal'});
set(gcf,'NumberTitle','Off', 'Name','Filtered Signal vs. Actual Signal');

%}


